// main.js
//
// gdShredder. Secure deletion of data from the Google Desktop Sidebar.
// Copyright  2006 Aaron Feuer / Airbear Software (aefeuer@airbearsoftware.com).
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
// 02111-1307, USA.
//

plugin.onAddCustomMenuItems = AddCustomMenuItems;  // handler to add menu items    
plugin.onShowOptionsDlg = ShowOptions;

var curVersion="1.0.0.0";

options.defaultValue("transparency") = 10;
options.defaultValue("showResults")=false;
options.defaultValue("statusHidden")=true;
options.defaultValue("DontAskForThisUpdate")=0;

var kVersion=2;

  var itemCount=0,
  timerId=0,
  arrItems=new Array,
  ForWriting = 2,
  TristateTrue=-1,
  recycleBin=false,
  wipeFreeSpaceDisk="",
  curTrans=options("transparency"),
  currentlyShredding=false;

function btnShredder_ondragover() {
	
  //
  // Don't allow the drag/drop by default:
  //
  event.returnValue = false;
  

  if(recycleBin || wipeFreeSpaceDisk!="")
    return;
  //
  // Do a quick scan to see if we think there is a file system item in the drag:
  //
	try{
	  var e = new Enumerator( event.dragFiles );
	  for( ; !e.atEnd(); e.moveNext() ) {
		var path = e.item();
	
		//
		// If it is a file or a folder, accept the drag:
		//
		if( ( system.filesystem.FolderExists( path ) ) ||
			( system.filesystem.FileExists( path ) ) ) {
		  event.returnValue = true;
		  imgShredderHot.opacity=0;
		  showHotShredder();
		  break;
		}
	  }
	} catch(e){
	
	}
}

function btnShredder_ondragdrop() {
    AddFiles(event.dragFiles);
  
}

function btnShredder_ondragout() {

	hideHotShredder()
}

function btnArrow_onclick(){
AddFiles(BrowseForFiles(""));
}

function Show(element, time, done){
	beginAnimation(element.name + ".opacity=event.value;" + ((done!="")?("if(event.value==255) {" + done + "}"):("")),element.opacity,255,time);
}

function Hide(element, time, done){
	beginAnimation(element.name + ".opacity=event.value;" + ((done!="")?("if(event.value==0) {" + done + "}"):("")),element.opacity,0,time);
}

function Hide2(element1, element2, time){
	beginAnimation(element1.name + ".opacity=event.value;" + element2.name + ".opacity=event.value;",255,0,time);
}



function showHotShredder(){
	Show(imgShredderHot,250);
}

function hideHotShredder(){
	Hide(imgShredderHot,250);
}

function normalToConfirmSolo(noTrans){
if (noTrans){
    btnShredderConfirm.opacity=255;
    btnArrow.opacity=0;
}else
	beginAnimation("btnShredderConfirm.opacity=event.value;btnArrow.opacity=255-event.value;",0,255,250);
}


function btnCancel_onclick(){
    lblItemInfo.tooltip=lblItemInfo.innerText;
    clearInterval(timerId);
	BackToNormal();
	EraseQueue();
}

function btnShred_onclick(){
    currentlyShredding=true;
    btnShredderConfirm.dropTarget=false;
    lblItemInfo.enabled=false;
    lblItemInfo.underline=false;

    WriteTempFile("gdshredder.out.tmp","0");

	timerId=SetInterval("updateStatus()",100);
	
	lblItemInfo.innerText=SHREDDING;
	lblItemInfo.tooltip=SHREDDING;
	
    if (recycleBin){
    	Hide(btnShred,400);
        ExecuteShredder("-recycled");
    }else if (wipeFreeSpaceDisk!=""){
    	Hide2(btnShred,lblDrive,400);
        ExecuteShredder("-disk " + wipeFreeSpaceDisk);
    }
    else{
    	Hide2(btnShred,btnArrow,400);
        WriteArrayTempFile("gdshredder.in.tmp",arrItems);
        ExecuteShredder("-infile");
    }
    EraseQueue();
	
}

function updateStatus(){
try{
    if(TempFileExists("gdshredder.out.tmp")){
        shredProgress.value=ReadTempFile("gdshredder.out.tmp")*1.5;
    }else{
        clearInterval(timerId);
        BackToNormal();
    }
}catch(e){

}
}


function BackToNormal(){
currentlyShredding=false;
CleanupFiles();
itemCount=0;
recycleBin=false;
wipeFreeSpaceDisk="";
lastFileName="";
arrItems=null;
arrItems=new Array;
btnShredder.visible=true;
Show(btnArrow,500);
Hide(btnShredderConfirm,500,"BackToNormal2()");

}


function BackToNormal2(){
	btnShred.opacity=255;
	shredProgress.value=0;
	btnShredderConfirm.dropTarget=true;
    lblItemInfo.enabled=true;
    lblItemInfo.underline=true;
    lblDrive.visible=false;
}

function onUnload(){
    if(ShredderIsRunning() ) 
        ExecuteShredder("-show");
    else
        CleanupFiles();
}

function ShredderIsRunning(){
    if(TempFileExists("gdshredder.out.tmp")){
        ExecuteShredder("-check",true); //delete the temp file if it the shredder is closed and the file still exists
        if(TempFileExists("gdshredder.out.tmp"))
            return true;
    }
    return false;
}

function showItems(){
var msg=WILL_BE_SHREDDED + "\n";

for (i=0;i<arrItems.length; i++){
	msg+="\n"+arrItems[i];
}



var WinShell = new ActiveXObject("WScript.Shell");
//WinShell.Popup(msg);
alert(msg);
}

function GetTempFilePath(tname){


   var tfolder, TemporaryFolder = 2;

   tfolder = system.filesystem.GetSpecialFolder(TemporaryFolder);

   return tfolder.path + "\\" + tname;

}

function ReadTempFile(tname)

{
    var tfile, ForReading = 1, retVal;
    try{

       tfile = system.filesystem.OpenTextFile (GetTempFilePath(tname), ForReading);
        
       retVal=tfile.ReadAll();
       
       tfile.Close();
       return retVal;
    }catch(e){
       if (tfile)
           tfile.Close();
       return ""; 
    }   


}

function TempFileExists(tname)
{
   return system.filesystem.FileExists (GetTempFilePath(tname));

}


function DeleteTempFile(tname)
{
    try{
        system.filesystem.DeleteFile (GetTempFilePath(tname),true)
        return true;
    }catch(e)
    {
        return false;
    }
}

function WriteTempFile(tname, content)
{
   var tfile;

   tfile = system.filesystem.OpenTextFile (GetTempFilePath(tname), ForWriting, true);
   
   tfile.Write (content)
   
   tfile.Close();
}

function WriteArrayTempFile(tname, contentArray)
{
   var ErrorFiles="";
   var tfile;

   tfile = system.filesystem.OpenTextFile (GetTempFilePath(tname), ForWriting, true);
  
  var e = new Enumerator(contentArray);
  for( ; !e.atEnd(); e.moveNext() ) {
    var txt=e.item();
    try{
        tfile.Write(txt + "\n");
    } catch(eObj){
        ErrorFiles+=txt+"\n";
    }
  }
   
    tfile.Close();
    if(ErrorFiles)
        alert(CANNOT_BE_SHREDDED.replace("%1",ErrorFiles));
}

function onLoad(){
if(options("licenseVersion")!=curVersion && confirm(LEGAL)){
	ShowGPL();
}
	options("licenseVersion")=curVersion;

    wholePlugin.opacity=255*((100-curTrans)/100);
    LoadQueue();
    CheckForUpdates();

}

function AddFiles(fileList){


var lastItemName;
  var e = new Enumerator(fileList);
  
  for( ; !e.atEnd(); e.moveNext() ) {
    lastItemName=e.item();
    
    if(system.filesystem.FolderExists(lastItemName) || system.filesystem.FileExists(lastItemName)){
		itemCount++;
		arrItems.push(lastItemName);
	}
  }
  
  if (itemCount==0)
    return;
    
      if (itemCount>1){
	    lblItemInfo.trimming="none";
	    lblItemInfo.innerText=X_ITEMS.replace("%1",itemCount);
	    lblItemInfo.tooltip=CLICK_HERE_ITEMS.replace("%1",itemCount);
      }else{
	    lblItemInfo.trimming="path-ellipsis";
	    lblItemInfo.innerText =lastItemName; //just show last file/folder name
	    lblItemInfo.tooltip=lblItemInfo.innerText;
      }
      
      btnShredder.visible=false;
      btnShredderConfirm.opacity=255;
	  hideHotShredder();
	  
	  SaveQueue();

}

function CleanupFiles(){

DeleteTempFile("gdshredder.out.tmp");
DeleteTempFile("gdshredder.in.tmp");

}



function AddCustomMenuItems(menu) {


	  menu.AddItem(ONLINE_HELP,0,openOnlineHelp);
      menu.AddItem("", 0, 0);
      menu.AddItem(SHRED_RECYCLE_BIN, (arrItems.length>0)?gddMenuItemFlagGrayed:0, EraseRecycleBin);
      var diskMenu=menu.AddPopup(SHRED_FREE_SPACE);
          CreateDriveMenu(diskMenu);
          
      menu.AddItem("", 0, 0);
      menu.AddItem(SHOW_RESULTS, (currentlyShredding?gddMenuItemFlagGrayed:0) + (options("showResults")?gddMenuItemFlagChecked:0), ChangeShowResults);
      menu.AddItem((options("statusHidden")?SHOW_STATUS_WND:HIDE_STATUS_WND), (currentlyShredding?0:gddMenuItemFlagGrayed), ToggleStatusWindow);
      menu.AddItem("", 0, 0);
      menu.AddItem(CHECK_FOR_UPDATES, 0, onUpdatesClicked);
      menu.AddItem("", 0, 0);
      var transparencyMenu=menu.AddPopup(TRANSPARENCY);
      for(var i=0;i<=90;i+=10)
          transparencyMenu.AddItem(i + "%", (i==curTrans)?gddMenuItemFlagChecked:0, onTransparencyChange);

}
function CreateDriveMenu(diskMenu)
{
   diskMenu.AddItem(DISK_ALL,(arrItems.length>0)?gddMenuItemFlagGrayed:0,WipeFreeSpace);
   var n, e, x;
   e = new Enumerator(system.filesystem.Drives);
   for (; !e.atEnd(); e.moveNext())
   {
      x = e.item();
      diskMenu.AddItem(x.DriveLetter + ":",(arrItems.length>0)?gddMenuItemFlagGrayed:0,WipeFreeSpace);
   }
}

function ShowOptions(wnd){
    ExecuteShredder("-options");
    return false;
}

function EraseRecycleBin(item, notrans){
      recycleBin=true;
      lblItemInfo.trimming="none";
	  lblItemInfo.innerText =RECYCLE_BIN; //just show last file/folder name
	  arrItems.push(RECYCLE_BIN);
	  lblItemInfo.tooltip=lblItemInfo.innerText;
	  normalToConfirmSolo(notrans);
	  SaveQueue();
	  
}

function WipeFreeSpace(disk, notrans){
    var friendlyDesc;
    if(disk!=DISK_ALL){
        var diskObj=system.filesystem.GetDrive(disk);
        if (!diskObj.IsReady) {
            alert(DISK_NOT_READY.replace("%1",disk));
            return;
        }
        friendlyDesc=FREE_SPACE_ON.replace("%1",disk);
        wipeFreeSpaceDisk=disk.charAt(0);
    }else{
        friendlyDesc=FREE_SPACE_ON_ALL;
        wipeFreeSpaceDisk="all";
    }
    
    lblItemInfo.trimming="none";
    lblDrive.innerText=disk;
    lblDrive.tooltip=disk;
    lblDrive.opacity=255;
    lblDrive.visible=true;
    lblItemInfo.innerText = FREE_SPACE; //just show last file/folder name
    arrItems.push(friendlyDesc);
    lblItemInfo.tooltip=friendlyDesc;
    normalToConfirmSolo(notrans);
    SaveQueue();
}

function onTransparencyChange(newTransparency){
    curTrans=parseInt(newTransparency);
    options("transparency")=curTrans;
    wholePlugin.opacity=255*((100-curTrans)/100);
}

function SaveQueue(){
  options("itemCount")=itemCount;
  options("arrItems")=arrItems.join("\0");
  options("recycleBin")=recycleBin;
  options("wipeFreeSpaceDisk")=wipeFreeSpaceDisk;
}

function EraseQueue(){
  options.remove("itemCount");
  options.remove("arrItems");
  options.remove("recycleBin");
  options.remove("wipeFreeSpaceDisk");
}

function LoadQueue(){
    if (ShredderIsRunning()){
        currentlyShredding=true;
        btnShredderConfirm.dropTarget=false;
        lblItemInfo.enabled=false;
        lblItemInfo.underline=false;
	    timerId=SetInterval("updateStatus()",100);
        btnShredder.visible=false;
        btnShredderConfirm.opacity=255;	
	    lblItemInfo.innerText=SHREDDING;
	    lblItemInfo.tooltip=SHREDDING;
	    btnShred.opacity=0;
	    btnArrow.opacity=0;
	    updateStatus();
	    if(options("statusHidden"))
            ExecuteShredder("-hide");
    }else if(options.exists("arrItems")){
        if(options("recycleBin"))
            EraseRecycleBin("",true);
        else if (options("wipeFreeSpaceDisk")!="")
            WipeFreeSpace(options("wipeFreeSpaceDisk"),true);
        else{
              itemCount=options("itemCount");
              arrItems=options("arrItems").split("\0");
              if (itemCount>1){
                lblItemInfo.trimming="none";
                lblItemInfo.innerText=X_ITEMS.replace("%1",itemCount);
                lblItemInfo.tooltip=CLICK_HERE_ITEMS.replace("%1",itemCount);
              }else{
                lblItemInfo.trimming="path-ellipsis";
                lblItemInfo.innerText =arrItems[0]; //just show last file/folder name
                lblItemInfo.tooltip=lblItemInfo.innerText;
              }
              btnShredder.visible=false;
              btnShredderConfirm.opacity=255;
        }
    }
}

function ExecuteShredder(cmdLine, wait){
    var WshShell = new ActiveXObject("WScript.Shell");
    cmdLine="\"" + GetShredderFilename() + "\" " + (options("showResults")?"-results":"-resultsonerror") +" -datafolder \""  + GetTempFilePath("") + "\" " + (options("statusHidden")?"-starthidden ":"") + cmdLine;
    var oExec = WshShell.Run(cmdLine,1,wait);
}

function ChangeShowResults(){
options("showResults")=!options("showResults");
}

function ToggleStatusWindow(){
    if(options("statusHidden"))
        ExecuteShredder("-show");
    else
        ExecuteShredder("-hide");
        
    options("statusHidden")=!options("statusHidden");
}

function GetShredderFilename(){
    var ShredderEXE=options("ShredderEXE");
    var ShredderDLL=options("ShredderDLL");
    if (options("extractedVersion") != curVersion || !system.filesystem.FileExists(ShredderEXE) || !system.filesystem.FileExists(ShredderDLL)){
        //the files haven't already been extracted so let's extract them
        var ShredderEXETemp=storage.extract("gdshredder.exe");
        var ShredderDLLTemp=storage.extract("gdshredder.dll");
        
        
        //we need to keep the original filenames, so we extract the items to their own temp folder
        var tempFolder=CreateTempFolder();
        
        var ShredderEXE=tempFolder + "\\gdShredder.exe";
        var ShredderDLL=tempFolder + "\\gdShredder.dll";
        
        system.filesystem.MoveFile(ShredderEXETemp, ShredderEXE);
        system.filesystem.MoveFile(ShredderDLLTemp, ShredderDLL);
        
        options("ShredderEXE")=ShredderEXE;
        options("ShredderDLL")=ShredderDLL;
        options("extractedVersion")=curVersion;
    }

    return ShredderEXE;
}

function CreateTempFolder()
{
   return system.filesystem.CreateFolder(GetTempFilePath(system.filesystem.GetTempName()));
}


function CheckForUpdates(){
	    var DownloadClass=new cDownloader(HandleUpdate,"http://update.airbearsoftware.com/gdshredder?rand=" + Math.random() + "&LANGID" + LANGID + "&langnum=" + LANGNUM,null,false);
	    DownloadClass.DownloadPage();
	    DownloadClass=null;
    	
	    function HandleUpdate(text){
            var DOMDoc=new DOMDocument();
            if (DOMDoc.loadXML(text)){
                  var UpdateTree = DOMDoc.getElementsByTagName("update");
                  var LatestVersion = (UpdateTree[0].getElementsByTagName("latestversion")[0].text);
                  var Message = UpdateTree[0].getElementsByTagName("message")[0].text;
                  var URL = UpdateTree[0].getElementsByTagName("url")[0].text;
                  
                  if (LatestVersion>kVersion && LatestVersion>options("DontAskForThisUpdate")) {
                        options("DontAskForThisUpdate")=LatestVersion;
                        if(confirm(Message)){
                            var WinShell = new ActiveXObject("Shell.Application");
                            WinShell.ShellExecute(URL);
                        }
                  }
            }
        }
}
   
function cDownloader(onDoneDownloading,url, postData, onError){
	var http = new XMLHttpRequest();
	http.onreadystatechange = OnData;
	this.DownloadPage=DownloadPage;
	function DownloadPage(){	
		if (postData){
			http.open("POST", url, true);
			http.setRequestHeader('Content-Type',
			'application/x-www-form-urlencoded');
			http.send(postData);
		}else{
			http.open("GET", url, true);
			http.send();
		}
	}
	function OnData() {
		if (http.readyState == 4) { // completed?
			if (http.status==200){
				var dlText=http.responseText;
				onDoneDownloading(dlText);
			}
			http=null;

		}
	}
}

function onUpdatesClicked(){
    options("DontAskForThisUpdate")=0;
    CheckForUpdates();
}

function openOnlineHelp(){
    var WinShell = new ActiveXObject("Shell.Application");
	WinShell.ShellExecute("http://www.airbearsoftware.com/software/gdshredder/help");
}

function ShowGPL(){
    var WinShell = new ActiveXObject("Shell.Application");
	WinShell.ShellExecute(storage.extract("COPYING.txt"));
}